# Smrtr DataGrid [![Build Status](https://travis-ci.org/joegreen88/smrtr-datagrid.png?branch=master)](https://travis-ci.org/joegreen88/smrtr-datagrid) [ ![Codeship Status for joegreen88/smrtr-datagrid](https://www.codeship.io/projects/fb908060-a44b-0130-ffc3-1e80e73e8cde/status?branch=master)](https://www.codeship.io/projects/3644) [![Coverage Status](https://coveralls.io/repos/joegreen88/smrtr-datagrid/badge.png?branch=master)](https://coveralls.io/r/joegreen88/smrtr-datagrid?branch=master)

Smrtr DataGrid is a one-stop-shop for manipulating tabular data on the back-end. It's essentially a 2D-array wrapper class with methods for import/export & data manipulation. It's a general purpose tool with a fluent interface which we at smrtr use all the time.

## Why Smrtr DataGrid?

Smrtr DataGrid provides an easy to use, portable interface for working with tabular data. It has an intuitive, easy to learn API which makes many common tasks a breeze. It's built to a comprehensive set of requirements and controlled by a single PHP class to help you to maximise your productivity and flexibility. The quality of this tool is ensured by the execution of rigorous unit tests before every release.

## Benefits for Developers

If you're a developer, DataGrid will take the repetitive hassle out of many tasks which you may face frequently. DataGrid has clear applications in reporting and analysis. DataGrid will handle reading, converting and writing data between CSV and JSON. DataGrid keeps track of keys and labels too. There's even search functionality which uses a schema inspired by jQuery and lets you find data as easily as $Grid->findRows('name*=Joe').

## About the Code

The code has been written quite cleanly in an effort to be self-documenting. In addition, phpdocumentor comment blocks have been liberally used, which should provide you with type hints and documentation tooltips in Netbeans IDE for php.

# Tutorial
 - [Getting Started][1]
 - [Keys & Labels][2]
 - [Data setters][3]
 - [Data getters][4]
 - [Vector objects][5]
 - [Searching][6]
 - [Iterating & Filtering][7]

[1]: http://datagrid.smrtr.co.uk/tutorial/getting-started
[2]: http://datagrid.smrtr.co.uk/tutorial/keys--labels
[3]: http://datagrid.smrtr.co.uk/tutorial/data-setters
[4]: http://datagrid.smrtr.co.uk/tutorial/data-getters
[5]: http://datagrid.smrtr.co.uk/tutorial/vector-objects
[6]: http://datagrid.smrtr.co.uk/tutorial/searching
[7]: http://datagrid.smrtr.co.uk/tutorial/iterating--filtering
